import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import javax.help.*;
import javax.swing.filechooser.*;

public class FrameVisJPEG extends JFrame {
    public static FrameVisJPEG vis;
    public static String standardBilder[] = {"test2.gif", "test3.gif", "test4.gif", "test5.gif", 
                                             "challenger2.jpg", "tria.jpg", "shuttle.jpg", "frog.jpg",
                                             "blumen.jpg", "monument.jpg", "schrift.jpg", "schloss.jpg",
                                             "ayersrock.jpg", "fruechte.jpg", "jit.jpg", "charly.gif"};
    private static String bildComboElemz[] = {"Haus (192x144)", "Raytrace-Ringe (800x600)", 
                                              "Papageien (192x128)", "Raytrace-Brcke (192x144)",
                                              "Challenger (640x310)", "Triathlon (384x288)",
                                              "Space Shuttle (512x384)", "Frosch (240x180)",
                                              "Blumen (256x209)", "Monument Valley (192x144)", "Schrift (192x144)",
                                              "Neuschwanstein (512x384)", "Ayers Rock (365x237)",
                                              "Frchte (256x171)", "Just in Time (316x200)", 
                                              "Charlie Brown (544x398)"};

    boolean scrollingEnabled = false;
    public JPEGParameter parameter = new JPEGParameter();
    public JPEGImage ourImage = new JPEGImage(standardBilder[0], scrollingEnabled);
    
    private JComboBox bildAuswahlCombo;
    private File eigenesBildDirectory = null;
    private int bildAuswahlIndex;
    boolean differenzbild = false;
    OurImage original,komprimiert;
    DragListener orgImgListener;
    boolean dragImgupdateInProgress = false;
  
    private final int pSizeX=192;        // Standartbreite eines Bildes
    private final int pSizeY=144;        // Standarthoehe
    private int controlwidth=220;        // Breite der Hauptkontrolle
    private final int kBalkenHeight=40;
    static int gesamtKompression=20;
    private final Dimension pDim=new Dimension(pSizeX, pSizeY);
    private JPanel panOHeading, panKHeading, panNeu, panOrig, panKomp, panButtons, panBalken,
                   panBHeading, panOrigCtrl, panKompCtrl, panInfo, panFehler, panBar;
    private PanelFarbraum panFR;
    private PanelDCT panDCT;
    private PanelQuantisierung panQS;
    private PanelZickZackScan panZZS;
    private PanelDPCMRLE panDPCM_RLE;
    private PanelEntropie panEK;
    private JLabel labImageOrig, labImageKomp, labGesKomp, labFehler;
    private JProgressBar kProgressBar;
    private JTabbedPane tp;
    private JButton scrollButton;
	
    private JButton createButton(String s, int keyevent, ActionListener a)
    {
        JButton dummy=new JButton(s);
        dummy.setMnemonic(keyevent);
        dummy.addActionListener(a);
      
        return dummy;
    }
	
    private JLabel createLabel(String s, JPanel p)
    {
        JLabel dummy=new JLabel(s);
        p.add(dummy,BorderLayout.CENTER);
        Dimension dim=new Dimension(controlwidth,dummy.getPreferredSize().height);
        p.setMinimumSize(dim);
        p.setPreferredSize(dim);
        p.setMaximumSize(dim);
		
        return dummy;
    }
	
    private JRadioButton createRadioButton(String s, int keyevent, ActionListener a, ButtonGroup g, boolean selected)
    {
        JRadioButton dummy = new JRadioButton(s);
        dummy.setMnemonic(keyevent);
        dummy.setActionCommand(s);
        dummy.setSelected(selected);
        dummy.addActionListener(a);
        g.add(dummy);
		
        return dummy;
    }

    private void setPanelSize(JPanel pan, Dimension d)
    {
        pan.setMinimumSize(d);
        pan.setPreferredSize(d);
        pan.setMaximumSize(d);
    }
	
    /**
     * Wird aufgerufen, wenn aus der Combo Box was ausgewhlt wird
     * @author Hari
     * @author Raimund Specht
     * @Version 2 - 13.02.2000
     */
    private void bildAuswahl() {
        int comboIndex = bildAuswahlCombo.getSelectedIndex();
        if (comboIndex == bildAuswahlIndex) return;
        Dialog msgDialog = MessageWindow.popup("Bitte warten...");
        ourImage=new JPEGImage(standardBilder[comboIndex], scrollingEnabled);
        parameter.filename = standardBilder[comboIndex];
        updateAll();
        msgDialog.dispose();
        bildAuswahlIndex=comboIndex;
        bildAuswahlCombo.setSelectedIndex(bildAuswahlIndex);
    }
    
    private JComponent mainControl(boolean neu)
    {
        JPanel p=new JPanel();
		
        if (neu) {
            ActionListener al=new ActionListener() { 
                public void actionPerformed(ActionEvent e) {
                    Dialog msgDialog = MessageWindow.popup("Bitte warten...");
                    if (e.getActionCommand()=="scrollen") {
                        setScrollingEnabled(true);
                    }
                    
                    if (e.getActionCommand()=="skalieren") {
                        setScrollingEnabled(false);
                    }
                    
                    if (e.getActionCommand()=="Differenz") {
                        if (!differenzbild) {
                            differenzbild=true;
                            panKomp.remove(komprimiert);
                            komprimiert=new OurImage(ourImage.getDifferenceImage(parameter));
                            komprimiert.setPreferredSize(pDim);
                            panKomp.add(komprimiert);
                            validate();
                        }
                    }
                    
                    if (e.getActionCommand()=="Normal") {
                        if (differenzbild) {
                            differenzbild=false;
                            panKomp.remove(komprimiert);
                            komprimiert=new OurImage(ourImage.getDecompressedJPEGImage(parameter));
                            komprimiert.setPreferredSize(pDim);
                            panKomp.add(komprimiert);
                            validate();
                        }
                    }
                    
                    if (e.getActionCommand()=="Neu berechnen") {
                        updateAll();
                    }
                    
                    if (e.getActionCommand()=="Eigenes Bild laden...") {
                        JFileChooser fc = new JFileChooser();
                        FileFilter imgFilter = new ImageFilter();
                        fc.addChoosableFileFilter(imgFilter);
                        fc.setFileFilter(imgFilter);
                        fc.setFileView(new ImageFileView());
                        fc.setAccessory(new ImagePreview(fc));
                        fc.setDialogType(JFileChooser.OPEN_DIALOG);
                        fc.setDialogTitle("Eigenes Bild laden");
                        if (eigenesBildDirectory!=null)
                            fc.setCurrentDirectory(eigenesBildDirectory);
                        int returnVal = fc.showDialog(vis, "Laden");
                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                            msgDialog = MessageWindow.popup("Bitte warten...");
                            File file = fc.getSelectedFile();
                            ourImage=new JPEGImage(file.getPath(), scrollingEnabled);
                            parameter.filename = file.getPath();
                            eigenesBildDirectory = fc.getCurrentDirectory();
                            updateAll();
                            msgDialog.dispose();
                            bildAuswahlIndex=-1;
                            bildAuswahlCombo.setSelectedIndex(bildAuswahlIndex);
                        }
                    }
                    
                    if (e.getActionCommand()=="Bild speichern...") {
                        JFileChooser fc = new JFileChooser();
                        fc.addChoosableFileFilter(new ImageFilter());
                        fc.setDialogType(JFileChooser.SAVE_DIALOG);
                        fc.setDialogTitle("Bild speichern");
                        if (eigenesBildDirectory!=null)
                            fc.setCurrentDirectory(eigenesBildDirectory);
                        int returnVal = fc.showDialog(vis, "Speichern");
                        if (returnVal == JFileChooser.APPROVE_OPTION) {
                            File file = fc.getSelectedFile();
                            if (file != null) {
                                if (!file.isDirectory()) {
                                    String fileName=fc.getSelectedFile().getAbsolutePath();
                                    eigenesBildDirectory = fc.getCurrentDirectory();
                                    if (ourImage.writeToFile(fileName))
                                        JOptionPane.showMessageDialog(null, "Bild gespeichert!", "", JOptionPane.INFORMATION_MESSAGE);
                                    else
                                        JOptionPane.showMessageDialog(null, "Bild konnte nicht gespeichert werden!", "Allgemeine Schmutzverletzung", JOptionPane.ERROR_MESSAGE);
                                }
                                else
                                    JOptionPane.showMessageDialog(null, "Du hast ein Verzeichnis ausgewhlt!", "Kernel panic", JOptionPane.ERROR_MESSAGE);
                            }
                        }
                    }
                    
                    msgDialog.dispose();
                }
            }; // end of ActionListener (?)
 	    
            // extrem Layout-Managing fr ein wenig Layout...
		
            p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));  // zuerst die ganzen Panels aufbauen
            p.setPreferredSize(new Dimension(controlwidth, 570));
            p.add(panInfo=new JPanel());
            p.add(panOHeading=new JPanel());
            p.add(panOrig=new JPanel());
            p.add(panOrigCtrl=new JPanel());
            p.add(panButtons=new JPanel());
            p.add(panNeu=new JPanel());
            p.add(panKHeading=new JPanel());
            p.add(panKomp=new JPanel());
            p.add(panKompCtrl=new JPanel());
            p.add(panBHeading=new JPanel());
            p.add(panBalken=new JPanel());
            p.add(panFehler=new JPanel());
            panBar= new JPanel();
            panInfo.setLayout(new BorderLayout());						// jeder braucht natrlich ein Layout
            panOHeading.setLayout(new BorderLayout());
            panOrig.setLayout(new BorderLayout());
            panOrigCtrl.setLayout(new FlowLayout());
            panButtons.setLayout(new GridLayout(4, 1, 0, 5));
            panKHeading.setLayout(new BorderLayout());
            panKomp.setLayout(new BorderLayout());
            panKompCtrl.setLayout(new FlowLayout());
            panNeu.setLayout(new BorderLayout());
            panBHeading.setLayout(new BorderLayout());
            panBalken.setLayout(new BorderLayout());
            panBar.setLayout(new BorderLayout());
            panFehler.setLayout(new BorderLayout());
            panOrig.setPreferredSize(pDim);
            panOrig.setMinimumSize(pDim);
            panKomp.setPreferredSize(pDim);
            panKomp.setMinimumSize(pDim);
																							// jetzt werden die einzelnen Elemente hinzugefgt
            JButton buttonInfo = createButton("Info",KeyEvent.VK_F, al);
            if (JavaHelpSystem.helpSystemAvailable) {
                CSH.setHelpIDString(buttonInfo, "intro.projekt");
                buttonInfo.addActionListener(new CSH.DisplayHelpFromSource(JavaHelpSystem.hb));
            } else {
                buttonInfo.setEnabled(false);
                buttonInfo.setToolTipText("HelpSet nicht gefunden.");
            }
            
            Dimension dimInfoPanel=new Dimension(pSizeX, buttonInfo.getPreferredSize().height);
            setPanelSize(panInfo, dimInfoPanel);

            buttonInfo.setMaximumSize(new Dimension(buttonInfo.getPreferredSize().width, buttonInfo.getPreferredSize().height));
            panInfo.add(buttonInfo, BorderLayout.EAST);
			
            labImageOrig=createLabel(" Originalbild:",panOHeading);
			
            ButtonGroup scrollGroup = new ButtonGroup();
            JRadioButton buttonScroll1 = createRadioButton("skalieren",KeyEvent.VK_K,al,scrollGroup,true);
            JRadioButton buttonScroll2 = createRadioButton("scrollen",KeyEvent.VK_C,al,scrollGroup,false);
            panOrigCtrl.add(buttonScroll1);
            panOrigCtrl.add(buttonScroll2);
			
            bildAuswahlCombo = new JComboBox(bildComboElemz);
            bildAuswahlIndex=0;

            bildAuswahlCombo.setSelectedIndex(bildAuswahlIndex); 
            //bildAuswahlCombo.setMaximumRowCount(bildAuswahlCombo.getItemCount());
            bildAuswahlCombo.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        bildAuswahl();
                    }
                }
            );
                
            panButtons.add(bildAuswahlCombo);
      
            JButton buttonLaden = createButton("Eigenes Bild laden...", KeyEvent.VK_E, al);
            if (!JPEG.isApplication) buttonLaden.setEnabled(false);
            panButtons.add(buttonLaden);
            
            JButton buttonSpeichern = createButton("Bild speichern...", KeyEvent.VK_S, al);
            if (!JPEG.isApplication) buttonSpeichern.setEnabled(false);
            panButtons.add(buttonSpeichern);

            JButton buttonBerechne = createButton("Neu berechnen", KeyEvent.VK_B, al);
            panButtons.add(buttonBerechne,BorderLayout.CENTER);	
            setPanelSize(panButtons, new Dimension(pSizeX, panButtons.getPreferredSize().height-10));
			
            labImageKomp=createLabel(" JPEG komprimiert:", panKHeading);

            ButtonGroup kompGroup = new ButtonGroup();
            JRadioButton buttonKomp1 = createRadioButton("Normal", KeyEvent.VK_N, al, kompGroup, true);
            JRadioButton buttonKomp2 = createRadioButton("Differenz", KeyEvent.VK_D, al, kompGroup, false);
            panKompCtrl.add(buttonKomp1);
            panKompCtrl.add(buttonKomp2);

            labGesKomp = createLabel(" Gesamtkompression um:", panBHeading);
		
            Dimension dimPanBalken=new Dimension(controlwidth, kBalkenHeight+10);
            setPanelSize(panBalken, dimPanBalken);
    	
            //labFehler = createLabel(" Entstandener Fehler: ", panFehler);
		
            // Jetzt kommt kurz was von Hari
            DragListener orgImgListener = new DragListener();
            panOrig.addMouseListener(orgImgListener);
            panOrig.addMouseMotionListener(orgImgListener);    
        } // if (neu)   (?)
		
        original=new OurImage(ourImage.getImage());
        original.setPreferredSize(pDim);
        original.setMinimumSize(pDim);
        panOrig.add(original, BorderLayout.CENTER);
        JPanel spacer = new JPanel();
        spacer.setPreferredSize(new Dimension(13, 192));
        panOrig.add(spacer, BorderLayout.WEST);
		
        if (differenzbild) {
            komprimiert=new OurImage(ourImage.getDifferenceImage(parameter));
            komprimiert.setPreferredSize(pDim);
        } else {
            komprimiert=new OurImage(ourImage.getDecompressedJPEGImage(parameter));
            komprimiert.setPreferredSize(pDim);
        }
        panKomp.add(komprimiert, BorderLayout.CENTER);
        spacer = new JPanel();
        spacer.setPreferredSize(new Dimension(13, 192));
        panKomp.add(spacer, BorderLayout.WEST);

        //labFehler.setText(" Entstandener Fehler: " + ourImage.getDeviance());  
		
        kProgressBar = new JProgressBar(JProgressBar.HORIZONTAL, 0, 100);
        kProgressBar.setValue(gesamtKompression);
        kProgressBar.setStringPainted(true);
        kProgressBar.setString((new Integer(100-gesamtKompression)).toString() + "%");
        kProgressBar.setToolTipText("Dateigre in Bezug auf das Original (=100%)");
        panBalken.add(kProgressBar, BorderLayout.CENTER);
        Dimension bardim=new Dimension(pSizeX, kProgressBar.getPreferredSize().height);
        setPanelSize(panBalken, bardim);
        //panBalken.add(panBar, BorderLayout.CENTER); 
		
        return p;
    }  // mainControl()
	
    
    private JComponent mainTabbedField() {
        JPanel p=new JPanel();
        p.setLayout(new BorderLayout());
        p.setPreferredSize(new Dimension(570, 570));

        tp = new JTabbedPane();
        tp.addTab("Farbraum", null,panFR = new PanelFarbraum());
        tp.addTab("DCT", null, panDCT = new PanelDCT());
        tp.addTab("Quantisierung", null, panQS = new PanelQuantisierung());
        tp.addTab("Zick-Zack-Scan", null, panZZS = new PanelZickZackScan());
        tp.addTab("DPCM + RLE", null, panDPCM_RLE = new PanelDPCMRLE());
        tp.addTab("Entropie-Kodierung", null, panEK = new PanelEntropie());
        // fr den Fall, da jemand die Tabs anklicken sollte :-)
        // wird vor dem Anzeigen auf jeden Fall ein Update der Seite durchgefhrt
        tp.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                updateCurrentPanel();
            }
        }); // end of addChangeListener
        
        
        // beim 1.mal Anzeigen sollte schon der 1. Tab gezeigt werden
        tp.setSelectedIndex(0);  
    
        p.add(tp,BorderLayout.CENTER);
        return p;
    }  // mainTabbedField()
	
    
    private void updateCurrentPanel() {
        switch (tp.getSelectedIndex()) {
            case 0 : panFR.update(); break;
            case 1 : panDCT.update(); break;
            case 2 : panQS.update(); break;
            case 3 : panZZS.update(); break;
            case 4 : panDPCM_RLE.update(); break;
            case 5 : panEK.update(); break;
        }
    }  // updateCurrentPanel()
	
    
    // falls jemand alles neu berechnen will, ohne die Bilder zu ndern
    // Verndert von Hari: nur noch aktuelles Panel updaten
    public void update() {
		updateCurrentPanel();
	}

	// fr die Auswahl eines neuen Bildes mu alles neu durchlaufen werden
	// Verndert von Hari: Popup zugefgt
    private void updateAll() {
        Dialog msgDialog = MessageWindow.popup("Bitte warten...");

        panOrig.remove(original);    
        panKomp.remove(komprimiert);
        panBar.remove(kProgressBar);
        mainControl(false);
        updateCurrentPanel();
        validate();
		
        msgDialog.dispose();
    }  // updateAll()
    
	
    // durch den Klick auf "Weiter" oder "Zurck" wird der nchste, bzw. vorige
    // Panel gleich upgedated (s. MouseAdapter fr JTabbedPane)
    public void setActivePanel(int panel) {
        int number=tp.getSelectedIndex()+panel;
        if (number<0) number=0;
        if (number>5) number=5;
        tp.setSelectedIndex(number);
        switch (number) {
            case 0 : panFR.update(); break;
            case 1 : panDCT.update(); break;
            case 2 : panQS.update(); break;
            case 3 : panZZS.update(); break;
            case 4 : panDPCM_RLE.update(); break;
            case 5 : panEK.update(); break;
        }
    } // setActivePanel()

    
    // Konstruktor fuer das Applet bzw. den JFrame
    // Standartmaessig wird mit einer groesse von 800x600 initiallisiert.
    public FrameVisJPEG() {
        super("JPEG - Visualisierung");
        vis = this;
          
        JPanel mainPanel=new JPanel();
        mainPanel.setLayout(new BorderLayout());  
        Dimension dimWindow = new Dimension(800, 600);
        mainPanel.setMinimumSize(dimWindow);
        mainPanel.setPreferredSize(dimWindow);
        mainPanel.setMaximumSize(dimWindow);
        JComponent c=vis.mainControl(true);
        c.setPreferredSize(new Dimension(controlwidth, 570));
        JComponent tf=vis.mainTabbedField();
        tf.setPreferredSize(new Dimension(800-controlwidth, 570));
        mainPanel.add(c, BorderLayout.WEST);
        mainPanel.add(tf, BorderLayout.CENTER);
        vis.getContentPane().add(mainPanel);
        setResizable(false); 
    
        // Das Fenster noch ein bisschen in die Mitte platzieren (von Hari spendiert)
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Dimension scrnSize= toolkit.getScreenSize();
        setLocation(scrnSize.width/2-dimWindow.width/2, scrnSize.height/2-dimWindow.height/2);
  	
        addWindowListener(
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) { 
                    if (JPEG.isApplication) {
                        System.exit(0);
                    } else {
                        setVisible(false);
                    }
                }
            }
        );
        
        vis.pack();        
        setVisible(true);
    } // FrameVisJPEG()
	
    /**
     * Schaltet zwischen Scroll- und Skalierungsmodus um.
     * Wird vom ActionListener des Buttons aufgerufen
     * Veranlasst das Neu Berechnen des aktuellen Panels
     * @author Hari
     * @version 1 - 10.1.2000
     */
    private void setScrollingEnabled(boolean b) {
        if (b == scrollingEnabled) return;
            
        scrollingEnabled = b;
        if (scrollingEnabled) {
            scrollingEnabled = true;
            vis.panOrig.setCursor(new Cursor(Cursor.MOVE_CURSOR));
        } else {
            scrollingEnabled = false;
            vis.panOrig.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        }
        
        if (vis.ourImage.getRohWidth()==192 && vis.ourImage.getRohHeight()==144) return;
			
        Dialog msgDialog = MessageWindow.popup("Bitte warten...");
        if (scrollingEnabled) {
            vis.parameter.xShift = 0;
            vis.parameter.yShift = 0;
            vis.ourImage.invalidate();
            vis.ourImage.rebuildFromRaw(true, 0, 0);
        } else {
            vis.ourImage.invalidate();
            vis.ourImage.rebuildFromRaw(false, vis.parameter.xShift, vis.parameter.yShift);
        }
        
        updateAll();
        msgDialog.dispose();	
    }  // setScrollingEnabled()

    
    /**
     * Updatet das Originalbild (das linx oben)
     * @author Hari
     * @version 1 - 10.1.2000
     */
    private void updateOrigImg() {
        panOrig.remove(original);    
        original = new OurImage(ourImage.getImage());
        original.setPreferredSize(new Dimension(192, 144));
        panOrig.add(original);
        validate();
    }  // updateOrigImg()
	
    
    /**
     * Wird vom <CODE>DragListener</CODE> aufgerufen, wenn jemand das
     * Bild verschoben, aber noch nicht losgelassen hat
     * Veranlasst das Neu Zeichnen des Originalbildes
     * @author Hari
     * @version 1 - 10.1.2000
     * @param int xShift
     * @param int yShift
     */
    public void dragImagePreview(int xShift, int yShift) {
        if (!scrollingEnabled) return;
        
        dragImgupdateInProgress = true;
        vis.ourImage.setImageShift(xShift, yShift);
        updateOrigImg();
        dragImgupdateInProgress = false;
	}  // dragImagePreview()
	
    
    /**
     * Wird vom <CODE>DragListener</CODE> aufgerufen, wenn jemand das
     * Bild verschiebt und loslsst
     * Veranlasst das Neu Berechnen des aktuellen Panels
     * @author Hari
     * @version 1 - 10.1.2000
     */
    public void dragImageRecalc() {
        if (!scrollingEnabled || (ourImage.getRohWidth()==192&&ourImage.getRohHeight()==144)) return;
        
        Dialog msgDialog = MessageWindow.popup("Bitte warten...");
        dragImgupdateInProgress = true;
        ourImage.invalidate();
        updateCurrentPanel();
        msgDialog.dispose();
        dragImgupdateInProgress = false;
    }  // dragImageRecalc()
	
} // Klasse FrameVisJPEG



/**
 * Zum Verschieben des Originalbildes mit der Maus
 * @author Hari
 * @version 1 - 8.1.2000
 */
class DragListener extends MouseInputAdapter {
    private int xFrom, yFrom;
    private int lastXShift=0, lastYShift=0;
	
    public void mousePressed(MouseEvent e) {
        xFrom = e.getX();
        yFrom = e.getY();
        lastXShift = lastYShift = 0;
    }
    
    public void mouseReleased(MouseEvent e) {
        if (!FrameVisJPEG.vis.dragImgupdateInProgress && (e.getX()!=xFrom) || (e.getY()!=yFrom))
            FrameVisJPEG.vis.dragImageRecalc();
        lastXShift = lastYShift = 0;
    }
	
    public void mouseDragged(MouseEvent e) {
        FrameVisJPEG.vis.dragImagePreview((e.getX()-xFrom) - lastXShift, (e.getY()-yFrom) - lastYShift);
        lastXShift = e.getX() - xFrom;
        lastYShift = e.getY() - yFrom;
    }
} // Klasse DragListener