import java.awt.*;

/**
 * Parameter zur einheitlichen Darstellung der Oberflche
 * @author  Christoph Ballhause
 * @author  Raimund Specht
 * @version 4-08.12.1999
 */
public class GUIParameter
{
	/**
	 * 3D-Balkendiagram Parameter:
	 * Verhltnis der Hhe der Grundflche zur Gesamthhe des Diagramms
	 */
	public final static float DIAG_RATIO_Y=(float)0.33;
	/**
	 * 3D-Balkendiagram Parameter:
	 * Winkel der Parallel-Projektion. 1.0=45 0.5=26.5
	 */
	public final static float DIAG_RATIO_XY=(float)0.5;
	/**
	 * 3D-Balkendiagram Parameter:
	 * Gibt die Breite eines Balkens an, wenn 1.0 die Breite inkl. Zwischenenraum angibt.
	 */
	public final static float DIAG_WIDTH=(float)0.75;
	/**
	 * 3D-Balkendiagram Parameter:
	 * Gibt die Hhe eines Balkens an, wenn 1.0 die Hhe inkl. Zwischenenraum angibt.
	 */
	public final static float DIAG_HEIGHT=(float)0.75;
	
    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #LARGE_FONT
     */
    public final static Font fontLarge=new Font("SansSerif", Font.BOLD, 14);
    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #MEDIUM_FONT
     */
    public final static Font fontMedium=new Font("SansSerif", Font.PLAIN, 12);
    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #SMALL_FONT
     */
    public final static Font fontSmall=new Font("SansSerif", Font.PLAIN, 9);

    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #FONT_COLOR
     */
    public final static Color fontColor=Color.black;
    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #ACTIVE_BACKGROUND
     */
    public final static Color activeBackground=Color.lightGray;
    /**
     * @deprecated Nicht Java-konforme Schreibweise des <CODE>final</CODE>-Feldes.
     * @see #INACTIVE_BACKGROUND
     */
    public final static Color inactiveBackground=Color.white;

    // stattdessen neu:
    /**
     * Groer serifenloser Font
     * @deprecated Wir wollen den Java Look&Feel-Manager nicht vergewaltigen.
     */
    public final static Font LARGE_FONT=new Font("SansSerif", Font.BOLD, 14);
    /**
     * Mittelgroer serifenloser Font
     * @deprecated Wir wollen den Java Look&Feel-Manager nicht vergewaltigen.
     */
    public final static Font MEDIUM_FONT=new Font("SansSerif", Font.PLAIN, 12);
    /**
     * Kleiner serifenloser Font fr in <CODE>JTable</CODE>s angezeigte <CODE>Matrix</CODE>en.
     * @see Matrix
     */
    public final static Font SMALL_FONT=new Font("SansSerif", Font.PLAIN, 9);

    /**
     * Farbe fr normalen Text
     * @deprecated Wir wollen den Java Look&Feel-Manager nicht vergewaltigen.
     */
    public final static Color FONT_COLOR=Color.black;
    /**
     * Hintergrundfarbe fr <CODE>JTable</CODE>s, die vom Benutzer verndert werden knnen
     */
    public final static Color ACTIVE_BACKGROUND=Color.white;
    /**
     * Hintergrundfarbe fr <CODE>JTable</CODE>s, die NICHT vom Benutzer verndert werden knnen
     */
    public final static Color INACTIVE_BACKGROUND=Color.lightGray;
}