@echo off

if not "%1"=="quiet" goto meldung
shift
goto start

:meldung
echo --- UNI-ULM.DE ---

:start
if "%1"=="" goto ende
if "%1"=="all" make.bat quiet compile javahelp docs applet
if "%1"=="compile" goto compile
if "%1"=="applet" goto applet
if "%1"=="javahelp" goto javahelp
if "%1"=="docs" goto docs
if "%1"=="run" goto run
if "%1"=="clean" goto clean
if "%1"=="verbose" goto v_on
if "%1"=="verboseoff" goto v_off
goto hilfe

:compile
javac %jpgverbose% -O -deprecation -g:none -classpath .;jh.jar *.java
goto next

:javahelp
cd help
rmdir /s /q JavaHelpSearch
c:\Programme\JH1.1\javahelp\bin\jhindexer -nostopwords %jpgverbose% html
cd ..
goto next

:applet
if "%jpgverbose%"=="" goto applet2
jar -vcf jpeg.jar *.class
goto next
:applet2
jar -cf jpeg.jar *.class
goto next

:docs
rmdir /s /q docs
mkdir docs
javadoc %jpgverbose% -classpath .;jh.jar -use -version -author -windowtitle "Projektdokumentation: JPEG-Visualisierung" -d docs *.java
goto next

:run
java %jpgverbose% -noverify -cp .;jh.jar JPEG
goto next

:clean
if "%jpgverbose%"=="" goto clean2
del /s *.class
del /s jpeg.jar
del /s _test.jpg
rmdir /s /q docs
cd help
rmdir /s /q JavaHelpSearch
cd ..
goto next
:clean2
del *.class
del jpeg.jar
del _test.jpg
rmdir /s /q docs
cd help
rmdir /s /q JavaHelpSearch
cd ..
goto next

:v_on
set jpgverbose=-verbose
goto next

:v_off
set jpgverbose=
goto next

:next
shift
echo.
goto start

:hilfe
echo.
echo  MAKE [compile] [run] [applet] [javahelp] [docs] [all]
echo       [clean] [verbose] [verboseoff] [?]
echo.
echo    compile    - Java-Quelltexte compilieren
echo    run        - VisJPEG als "Application" starten
echo    applet     - JAR-Archive fr Start als Applet erzeugen
echo    javahelp   - JavaHelp Volltext-Suchindex erzeugen
echo    docs       - JavaDoc-Dateien erzeugen (Programm-Dokumentation)
echo    all        - Entspricht einem "make compile javahelp docs applet"
echo    clean      - Alle generierten Dateien lschen
echo    verbose    - "Verbose" fr javac,jar,... einschalten
echo    verboseoff - "Verbose" bei javac,jar,... ausschalten
echo    ?          - Diesen Hilfetext anzeigen
echo.
goto ende

:ende
set jpgverbose=
