/*******************************************
 *** Panel zur Veranschaulichung der DCT ***
 *** Christoph Ballhause      09.12.2k-1 ***
 *******************************************/

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.help.*;

public class PanelDCT extends JPanel
{
	private JLabel labTitle, labImage, labMat1, labMat2, lab3D1, lab3D2;	// Komponenten, als Attribute, damit spter aus
	private OurImage yComp, bars3D1, bars3D2;										// verschiedenen Methoden zugegriffen werden kann
	private JTable tabMat1, tabMat2;													// bentigt, um in update() entfernen zu knnen!
	private JButton butBack, butInfo, butFor;

	private JPanel panLower, panTitle, panNavigation, panInner;
	private JPanel panCell1l, panCell2l, panCell2r, panCell3l, panCell3r;
	
	private int lastMousePosX, lastMousePosY;
	
	// Constructor, der die Komponenten positioniert und den Listener einhngt
	public PanelDCT()
	{
		setLayout(new BorderLayout());
		addComponents(true);
	}
	
	// Erstellt die Komponenten und plaziert sie auf dem Panel
	// Falls start=true werden alle Komponenten erstellt, falls
	// start=false ist, werden alle Komponenten auer Labels neu
	// erstellt, dies wird in der Methode update() verwendet.
	private void addComponents(boolean start)
	{
		JPanel dummy;
		
		if (start)			// wenn alles eingefgt werden mu, auch Labels und die Buttons einfgen
		{
			// Das Layout mu nur beim Start einmal angelegt werden!
			// Vorsicht! Extreme runterhacking code ahead! ;-)
			add(panTitle=new JPanel(new BorderLayout()), BorderLayout.NORTH);
			panTitle.add(panNavigation=new JPanel(), BorderLayout.EAST);
			add(panLower=new JPanel(new BorderLayout()), BorderLayout.SOUTH);
			panLower.add(panInner=new JPanel(new GridLayout(3, 2, 20, 10)), BorderLayout.WEST);
			panLower.add(new JPanel(), BorderLayout.EAST);
			panInner.add(panCell1l=new JPanel(new BorderLayout()));
			panInner.add(new JPanel());
			panInner.add(panCell2l=new JPanel(new BorderLayout()));
			panInner.add(panCell2r=new JPanel(new BorderLayout()));
			panInner.add(panCell3l=new JPanel(new BorderLayout()));
			panInner.add(panCell3r=new JPanel(new BorderLayout()));
		
			// Die berschrift bleibt bestehen
			panTitle.add(labTitle=new JLabel(" Schritt 2: Diskrete Cosinus Transformation"), BorderLayout.WEST);
			
			// Jetzt noch die Navigations-Buttons
			butBack=new JButton("Zurck");
			butBack.setMnemonic(KeyEvent.VK_Z);
			butBack.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){FrameVisJPEG.vis.setActivePanel(-1);}});
			panNavigation.add(butBack, BorderLayout.WEST);
			butInfo=new JButton("Info");
			butInfo.setMnemonic(KeyEvent.VK_I);
              if (JavaHelpSystem.helpSystemAvailable) {
                  CSH.setHelpIDString(butInfo, "dct");
                  butInfo.addActionListener(new CSH.DisplayHelpFromSource(JavaHelpSystem.hb));
              } else { 
                  butInfo.setEnabled(false);
                  butInfo.setToolTipText("HelpSet nicht gefunden.");
              }
			panNavigation.add(butInfo, BorderLayout.CENTER);
			butFor=new JButton("Weiter");
			butFor.setMnemonic(KeyEvent.VK_W);
			butFor.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){FrameVisJPEG.vis.setActivePanel(1);}});
			panNavigation.add(butFor, BorderLayout.EAST);
		}
		
		// Jetzt noch die Komponenten einfgen, die immer neu erstellt werden mssen
		// (insbesondere sind dies jene, die upgedatet werden!)
		// Erstmal die Bilder (Y-Komponente und die beiden 3D-Bars)
		// Die Labels mssen auch neu gemacht werden, weil die Bilder alle auf temporre Panels geklebt sind
		panCell1l.add(labImage=new JLabel(" Y-Komponente"), BorderLayout.NORTH);
		panCell2l.add(labMat1=new JLabel(" Originalwerte im 8x8 Block"), BorderLayout.NORTH);
		panCell2r.add(labMat2=new JLabel(" DCT-transformierte Werte"), BorderLayout.NORTH);
		panCell3l.add(lab3D1=new JLabel(" 3D-Visualisierung"), BorderLayout.NORTH);
		panCell3r.add(lab3D2=new JLabel(" 3D-Visualisierung"), BorderLayout.NORTH);

		dummy=new JPanel();
		yComp=new OurImage(FrameVisJPEG.vis.ourImage.getMarkedYImage());
		yComp.setCursor(new Cursor(Cursor.HAND_CURSOR));
		yComp.addMouseListener(new MouseAdapter()
			{
				public void mouseClicked(MouseEvent e)
				{
					FrameVisJPEG.vis.ourImage.setMarker(e.getX(), e.getY());
					FrameVisJPEG.vis.update();
				}
            public void mouseEntered(MouseEvent e)
            {
                lastMousePosX=-10;  // unsichtbar
                lastMousePosY=-10;  // unsichtbar
            }
            public void mouseExited(MouseEvent e)
            {
                Graphics g=yComp.getGraphics();
                g.setXORMode(Color.black);
                g.setColor(Color.pink);
                g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
            }
			}
		);
		yComp.addMouseMotionListener(new MouseMotionAdapter()
		{
			public void mouseMoved(MouseEvent e)
			{
				Graphics g=yComp.getGraphics();
				g.setXORMode(Color.black);
				g.setColor(Color.pink);
				g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
				g.drawRect(lastMousePosX=(e.getX()/8)*8, lastMousePosY=(e.getY()/8)*8, 7, 7);
			}
		});
		lastMousePosX = -10;
		lastMousePosY = -10;

		yComp.setToolTipText("Klicken, um 8x8 Block auszuwhlen");
		yComp.setPreferredSize(new Dimension(192, 144));
		dummy.add(yComp);
		panCell1l.add(dummy, BorderLayout.CENTER);
		dummy=new JPanel();
		bars3D1=new OurImage(FrameVisJPEG.vis.ourImage.getMarkedBlock().paintBar3D(192, 144, Color.blue));
		bars3D1.setPreferredSize(new Dimension(192, 144));
		dummy.add(bars3D1);
		panCell3l.add(dummy, BorderLayout.CENTER);
		dummy=new JPanel();
		bars3D2=new OurImage(FrameVisJPEG.vis.ourImage.getMarkedBlock().getDCT().paintBar3D(192, 144, Color.blue));
		bars3D2.setPreferredSize(new Dimension(192, 144));
		dummy.add(bars3D2);
		panCell3r.add(dummy, BorderLayout.CENTER);
		
		// Dann noch die beiden Matrizen (Tabellen)
		dummy=new JPanel();
		dummy.add(FrameVisJPEG.vis.ourImage.getMarkedBlock().paintMatrix(GUIParameter.INACTIVE_BACKGROUND));
		panCell2l.add(dummy, BorderLayout.CENTER);
		dummy=new JPanel();
		dummy.add(FrameVisJPEG.vis.ourImage.getMarkedBlock().getDCT().paintMatrix(GUIParameter.INACTIVE_BACKGROUND));
		panCell2r.add(dummy, BorderLayout.CENTER);
	}
	
	// Update wird gerufen, wenn das Panel sich neu darstellen mu
	// Im Augenblick (d.h. bis mir was besseres eingefallen ist)
	// geschieht dies, indem alle Komponenten (ausser Labels) entfernt
	// werden und wieder neu eingefgt
	public void update()
	{
		panCell1l.removeAll();		// alle dynamischen Komponenten entfernen
		panCell2l.removeAll();
		panCell2r.removeAll();
		panCell3l.removeAll();
		panCell3r.removeAll();
		
		addComponents(false);		// und dann wieder einbauen...
		
		validate();
	}
}