import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import javax.help.*;


/**
 * Die Klasse <CODE>PanelDPCMRLE</CODE> kapselt das Panel, das 
 * fr die DPCM- und VLI-Kodierung zustndig ist. Es zeigt Statistiken
 * zur jeweiligen Kodierung an.
 * @author Marco Gebbert, Hari
 * @version 2 - 30.12.99
 */

public class PanelDPCMRLE extends JPanel{
    JPanel dynpanel, compressPanel, yImage;
    JPEGParameter lastParams;
    int compressionRatio;
    JPanel vliDiagramm;
    private int lastMousePosX, lastMousePosY;

  
    /**
     * Der Konstruktor fgt dem Panel die einzelnen Komponenten hinzu
     * und instanziert es.
     * @author Marco Gebbert, Hari
     * @version 2 - 30.12.99
     */
    public PanelDPCMRLE() {
        setLayout(new BorderLayout());
        addKomponets(true);
        validate();
    }

    
    private void addKomponets(boolean firststart) {
        JPanel p, p2, p3, p4, flow, flow2;
        JButton forwardButton, infoButton, backButton;
        JLabel mylabel;
        String vor, nach;
        Image rohImage;
        ImageProducer ImProd;
        BufferedImage myImage;
        OurImage dpcmDiagramm;
        Graphics myG;
        Block quantBlock;
        FloatBlock dctBlock;
        Matrix quantMatrix;
        int size, test;


        if (firststart) {
            p = new JPanel();
            p2 = new JPanel();
            p.setLayout(new BorderLayout());
            mylabel = new JLabel(" Schritt 5: DPCM- und RLE-Kodierung");
            p.add(mylabel, BorderLayout.WEST);
            backButton = new JButton("Zurck");
            backButton.setMnemonic(KeyEvent.VK_Z);
            backButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    FrameVisJPEG.vis.setActivePanel(-1);
                }
            });
            
            p2.add(backButton);
            infoButton = new JButton("Info");
            infoButton.setMnemonic(KeyEvent.VK_I);
            if (JavaHelpSystem.helpSystemAvailable) {
                CSH.setHelpIDString(infoButton, "dpcmrle");
                infoButton.addActionListener(new CSH.DisplayHelpFromSource(JavaHelpSystem.hb));
            } else {
                infoButton.setEnabled(false);
                infoButton.setToolTipText("HelpSet nicht gefunden.");
            }
            p2.add(infoButton);
            forwardButton = new JButton("Weiter");
            forwardButton.setMnemonic(KeyEvent.VK_W);
            forwardButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    FrameVisJPEG.vis.setActivePanel(+1);
                }
            });
      
            p2.add(forwardButton);
            p.add(p2, BorderLayout.EAST);
            add(p, BorderLayout.NORTH);
      
            p=new JPanel();
            p.setLayout(new BorderLayout());
      
            dynpanel = new JPanel();
            dynpanel.setLayout(new BorderLayout());
            dynpanel.setMinimumSize(new Dimension(400, 535));
            dynpanel.setMaximumSize(new Dimension(400, 535));
            dynpanel.setPreferredSize(new Dimension(400, 535));

      
            p.add(dynpanel, BorderLayout.CENTER);
            //p.add(p2/*compressPanel*/, BorderLayout.EAST);
            add(p, BorderLayout.SOUTH);

            //add(dynpanel, BorderLayout.CENTER);
        } // if (firststart)
        
        compressPanel = new JPanel();
        compressPanel.setLayout(new BorderLayout());
      
        quantMatrix = FrameVisJPEG.vis.parameter.qMatrixLum;
        dctBlock = FrameVisJPEG.vis.ourImage.getMarkedBlock().getDCT();
        quantBlock = dctBlock.getQuantisiert(quantMatrix);
    	
        if (lastParams==null || !lastParams.equals(FrameVisJPEG.vis.parameter)) {
            Dialog msgDialog;
            msgDialog = MessageWindow.popup("Bitte warten...");
        
            lastParams = (JPEGParameter)FrameVisJPEG.vis.parameter.clone();
        
            // wir kriegen einen Vector mit dem vliDiagramm und dem compressionRatio
            Vector vec = FrameVisJPEG.vis.ourImage.getDPCMVLIStats();
            vliDiagramm = (JPanel)vec.elementAt(0);
            compressionRatio = ((Integer)vec.elementAt(1)).intValue();
        
            msgDialog.dispose();
        }
    
        p = new JPanel();
        p2 = new JPanel();
        p.setLayout(new BorderLayout());
        mylabel = new JLabel(" Y - Komponente:");
        p.add(mylabel, BorderLayout.NORTH);
        yImage = new OurImage(FrameVisJPEG.vis.ourImage.getMarkedYImage());
        yImage.setCursor(new Cursor(Cursor.HAND_CURSOR));
        yImage.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                FrameVisJPEG.vis.ourImage.setMarker(e.getX(), e.getY());
                FrameVisJPEG.vis.update();
            }
            public void mouseEntered(MouseEvent e) {
                lastMousePosX = -10;  // unsichtbar
                lastMousePosY = -10;  // unsichtbar
            }
            public void mouseExited(MouseEvent e) {
                Graphics g = yImage.getGraphics();
                g.setXORMode(Color.black);
                g.setColor(Color.pink);
                g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
            }
        });
        yImage.addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e) {
                Graphics g = yImage.getGraphics();
                g.setXORMode(Color.black);
                g.setColor(Color.pink);
                g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
                g.drawRect(lastMousePosX=(e.getX()/8)*8, lastMousePosY=(e.getY()/8)*8, 7, 7);
            }
        });
        lastMousePosX = -10;  // Maus-Positions-Markierungs-Block unsichtbar machen
        lastMousePosY = -10;  // Maus-Positions-Markierungs-Block unsichtbar machen
        yImage.setToolTipText("Klicken, um 8x8 Block auszuwhlen");
        yImage.setPreferredSize(new Dimension(192, 144));
        p2.add(yImage, BorderLayout.CENTER);
        p.add(p2, BorderLayout.WEST);
        //dynpanel.add(jp);
        
        flow = new JPanel();
        //flow.setLayout(new FlowLayout(FlowLayout.LEFT));
        flow.setLayout(new BorderLayout());
        flow.add(p, BorderLayout.WEST);

        p = new JPanel();
        p.setLayout(new BorderLayout());
   
        p.add(new JLabel("DPCM-Kodierung des DC-Wertes jedes Blocks:"), BorderLayout.NORTH);
        dpcmDiagramm = new OurImage(FrameVisJPEG.vis.ourImage.paintDPCMBar(350, 150, Color.green, Color.red, Color.yellow));
        dpcmDiagramm.setPreferredSize(new Dimension(350, 150));
        dpcmDiagramm.setMinimumSize(new Dimension(350, 150));
        dpcmDiagramm.setMaximumSize(new Dimension(350, 150));
        p.add(dpcmDiagramm, BorderLayout.SOUTH);
        flow.add(p, BorderLayout.EAST);
        dynpanel.add(flow, BorderLayout.NORTH);
    
        p4 = new JPanel();
        p4.setLayout(new GridLayout(2, 1));
        p = new JPanel();
        p.setLayout(new BorderLayout(15, 5));
        p2 = new JPanel();
        p2.setLayout(new BorderLayout());
        p3 = new JPanel();
        p3.setLayout(new BorderLayout());
        p.add(new JLabel("RLE- und Variable-Length-Integer-Kodierung der AC-Werte:"), BorderLayout.NORTH);
        flow = new JPanel();
        flow.setLayout(new FlowLayout(FlowLayout.LEFT));
        Vector vec = FrameVisJPEG.vis.ourImage.getRLEStrings();
        vor =(String) vec.elementAt(0);
        StringTokenizer tok = new StringTokenizer(vor, " ");
        while (tok.hasMoreTokens()) {
            vor=tok.nextToken();
            if (vor.equalsIgnoreCase("0")) {
                //setze Farbe
                JLabel l = new JLabel(vor);
                l.setForeground(Color.black);
                flow.add(l);
            } else {
                //setze Farbe
                JLabel l = new JLabel(vor);
                l.setForeground(Color.blue);
                flow.add(l);
            }
      
        }
        /*for (int i=0;i<100;i++){ //setzt leere Panels aus Formatierungsgrnden
              flow.add(new JLabel(" "));
        }*/
    
        p3.add(new JLabel("Vor Run Length-Encoding:"), BorderLayout.NORTH);
        p3.add(flow, BorderLayout.CENTER);
        p4.add(p3);
        flow2 = new JPanel();
        flow2.setLayout(new FlowLayout(FlowLayout.LEFT));
   

        size = vec.size();
        for (int i = 1 ; i<size;i++) {
            nach = (String) vec.elementAt(i);
            if (i%2 !=0) {
                //Farbe grn
                if (nach != "") {
                    StringTokenizer tok2 = new StringTokenizer(nach, " ");
                    while (tok2.hasMoreTokens()) {
                        nach=tok2.nextToken();
                        JLabel l = new JLabel(nach);
                        l.setForeground(Color.blue);
                        /*l.setMinimumSize(new Dimension(25, 10));
                        l.setMaximumSize(new Dimension(25, 10));
                        l.setPreferredSize(new Dimension(25, 10));*/
                        flow2.add(l);
                    } // while
                } // if
            } else {
                //Farbe rot
                StringTokenizer tok3 = new StringTokenizer(nach, " ");
                while (tok3.hasMoreTokens()) {
                    nach=tok3.nextToken();
                    JLabel l = new JLabel(nach);
                    l.setForeground(Color.black);
                    /*l.setMinimumSize(new Dimension(25, 10));
                    l.setMaximumSize(new Dimension(25, 10));
                    l.setPreferredSize(new Dimension(25, 10));*/
                    flow2.add(l);
                } // while
            } // if
        } // for
        /*for (int i=0;i<100;i++){  //setzt leere Panels aus Formatierungsgrnden
              flow2.add(new JLabel(" "));
        }*/
    
        p3 = new JPanel();
        p3.setLayout(new BorderLayout());
        p3.add(new JLabel("Nach Run Length-Encoding:"), BorderLayout.NORTH);
        p3.add(flow2, BorderLayout.CENTER);
        p4.add(p3);

        p.add(p4, BorderLayout.CENTER);
        //dynpanel.add(p);
        p2.add(p, BorderLayout.CENTER);
        p = new JPanel();
        p.setLayout(new BorderLayout(15, 5));

        p.add(new JLabel("Verteilung der Lngen nach VLI Kodierung:"), BorderLayout.NORTH);
        vliDiagramm.setPreferredSize(new Dimension(450, 150));
        vliDiagramm.setMinimumSize(new Dimension(450, 150));
        vliDiagramm.setMaximumSize(new Dimension(450, 150));
        p.add(vliDiagramm, BorderLayout.CENTER);
        p2.add(p, BorderLayout.SOUTH);
    
        dynpanel.add(p2, BorderLayout.CENTER);
    
        p = new JPanel();
        p2 = new JPanel();
        p2.setLayout(new BorderLayout());
        JPanel labelzPanel = new JPanel();
        labelzPanel.setLayout(new BoxLayout(labelzPanel, BoxLayout.Y_AXIS));
        labelzPanel.add(new JLabel("Kompression in"));
        labelzPanel.add(new JLabel("diesem Schritt um:"));
        p2.add(labelzPanel, BorderLayout.NORTH);
        JProgressBar progressBar = new JProgressBar(JProgressBar.VERTICAL);
        progressBar.setMinimum(0);
        if (compressionRatio>100)
            progressBar.setMaximum(compressionRatio);
        else
            progressBar.setMaximum(100);
        progressBar.setValue(compressionRatio);
        progressBar.setString((new Integer(100-compressionRatio)).toString() + "%");
        progressBar.setStringPainted(true);  
        p.add(progressBar);
        p2.add(p, BorderLayout.CENTER);
        compressPanel.add(p2, BorderLayout.EAST);
        p2=new JPanel();
        p2.setLayout(new BorderLayout());
        p2.add(compressPanel, BorderLayout.SOUTH);
        dynpanel.add(p2, BorderLayout.EAST);
    } // addKomponets()

    
    public void update() {
        dynpanel.removeAll(); 
        addKomponets(false);  
        validate();
    } //update
      
}