import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.help.*;
import java.util.*;

/**
 * Die Klasse <CODE>PanelEntropie</CODE> kapselt das Panel, das 
 * fr die DPCM- und VLI-Kodierung zustndig ist. Es zeigt Statistiken
 * zur jeweiligen Kodierung an.
 * @author Marco Gebbert, Hari
 * @version 2 - 30.12.99
 */

public class PanelEntropie extends JPanel{
    JPanel dynpanel, compressPanel,yImage;
    private JComboBox huffmanCombo;
    JPEGParameter lastParams;
    int huffmanRatio;
    JPanel tabellenDiagramm,nochDiagramm;
    JPanel bildDatenDiagramm;
    String[] huffmanComboStrings = {"Huffman, Standard", "Huffman, optimiert"};
    private int lastMousePosX, lastMousePosY;
    private JPanel yImgPanel;

  
    /**
     * Der Konstruktor <CODE>PanelEntropie</CODE> fgt dem Panel die einzelnen Komponenten hinzu
     * und instanziert es.
     * @author Marco Gebbert, Hari
     * @version 2 - 30.12.99
     */
    public PanelEntropie() {
        setLayout(new BorderLayout());
        addKomponets(true);
        validate();
    } // PanelEntropie()
  
    private void comboBoxAuswahl() {
        String matrixAuswahl;
        float faktorAuswahl;

        matrixAuswahl = (String)huffmanCombo.getSelectedItem();
        if (matrixAuswahl.compareTo(huffmanComboStrings[0]) == 0)
            FrameVisJPEG.vis.parameter.compressionType = JPEGParameter.HUFFMAN_STANDARD;
        if (matrixAuswahl.compareTo(huffmanComboStrings[1]) == 0)
            FrameVisJPEG.vis.parameter.compressionType = JPEGParameter.HUFFMAN_ADAPTIVE;
        update();
    } // comboBoxAuswahl()

    /**
     * Die Methode addKomponets fgt dem Panel alle ntigen Komponenten zu
     * 
     * @author Marco Gebbert
     * @version 1.0
     */

    private void addKomponets(boolean firststart) {
        JPanel p,p2,p3,bar2D,flow;
        JButton infoButton,forwardButton, backButton;
        JLabel mylabel;

        setLayout(new BorderLayout());    
        if (firststart) {
            p = new JPanel();
            p2 = new JPanel();
            p.setLayout(new BorderLayout());
      
            mylabel = new JLabel(" Schritt 6: Entropie-Kodierung");
            p.add(mylabel, BorderLayout.WEST);
            backButton = new JButton("Zurck");
            backButton.setMnemonic(KeyEvent.VK_Z);
            backButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                FrameVisJPEG.vis.setActivePanel(-1); }
            });
            
            p2.add(backButton);
            infoButton = new JButton("Info");
            infoButton.setMnemonic(KeyEvent.VK_I);
            if (JavaHelpSystem.helpSystemAvailable) {
                CSH.setHelpIDString(infoButton, "entropie");
                infoButton.addActionListener(new CSH.DisplayHelpFromSource(JavaHelpSystem.hb));
            } else {
                infoButton.setEnabled(false);
                infoButton.setToolTipText("HelpSet nicht gefunden.");
            }
            
            p2.add(infoButton);
            forwardButton = new JButton("Weiter");
            forwardButton.setMnemonic(KeyEvent.VK_W);
            forwardButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                FrameVisJPEG.vis.setActivePanel(+1); }
            });
            forwardButton.setEnabled(false);
            p2.add(forwardButton);
            p.add(p2, BorderLayout.EAST);
            add(p, BorderLayout.NORTH);
      
            compressPanel = new JPanel();
            compressPanel.setLayout(new BorderLayout());
            p3=new JPanel();
            p3.setLayout(new BorderLayout());
            p2=new JPanel();
            p2.setLayout(new BorderLayout());
            //p2.add(new JPanel());
            p2.add(compressPanel, BorderLayout.SOUTH);
      
            dynpanel = new JPanel();
            dynpanel.setLayout(new BorderLayout());
      
            p3.add(dynpanel, BorderLayout.CENTER);
            p3.add(p2, BorderLayout.EAST);
            add(p3, BorderLayout.SOUTH);
        }//if (firststart)

        if (lastParams==null || !lastParams.equals(FrameVisJPEG.vis.parameter)) {
            Dialog msgDialog;
            msgDialog = MessageWindow.popup("Bitte warten...");
        
            lastParams = (JPEGParameter)FrameVisJPEG.vis.parameter.clone();
        
            Vector vec = FrameVisJPEG.vis.ourImage.getHuffmanStats();
            tabellenDiagramm = (JPanel)vec.elementAt(0);
            bildDatenDiagramm = (JPanel)vec.elementAt(1);
            huffmanRatio = ((Integer)vec.elementAt(2)).intValue();
        
            msgDialog.dispose();
        }
    
    
        //Komponenten, die neu gezeichnet werden mssen
        if (firststart) {
            yImgPanel = new JPanel();
            yImgPanel.setLayout(new BorderLayout());
        }
        
        p2 = new JPanel();
        p2.setLayout(new BorderLayout());
        mylabel = new JLabel(" Y - Komponente:");
        yImgPanel.add(mylabel,BorderLayout.NORTH);
        yImage = new OurImage(FrameVisJPEG.vis.ourImage.getMarkedYImage());
        yImage.setCursor(new Cursor(Cursor.HAND_CURSOR));
        yImage.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                FrameVisJPEG.vis.ourImage.setMarker(e.getX(), e.getY());
                FrameVisJPEG.vis.update();
            }
            public void mouseEntered(MouseEvent e) {
                lastMousePosX = -10;  // unsichtbar
                lastMousePosY = -10;  // unsichtbar
            }
            public void mouseExited(MouseEvent e) {
                Graphics g = yImage.getGraphics();
                g.setXORMode(Color.black);
                g.setColor(Color.pink);
                g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
            }});
            
        yImage.addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e) {
                Graphics g = yImage.getGraphics();
                g.setXORMode(Color.black);
                g.setColor(Color.pink);
                g.drawRect(lastMousePosX, lastMousePosY, 7, 7);
                g.drawRect(lastMousePosX=(e.getX()/8)*8, lastMousePosY=(e.getY()/8)*8, 7, 7);
            }});
            
        lastMousePosX = -10;  // Maus-Positions-Markierungs-Block unsichtbar machen
        lastMousePosY = -10;  // Maus-Positions-Markierungs-Block unsichtbar machen
        yImage.setToolTipText("Klicken, um 8x8 Block auszuwhlen");
        yImage.setPreferredSize(new Dimension(192, 144));
        yImage.setMinimumSize(new Dimension(192, 144));
        yImage.setMaximumSize(new Dimension(192, 144));
        JPanel hilfsPanel = new JPanel();
        hilfsPanel.setLayout(new BorderLayout());
        hilfsPanel.add(yImage, BorderLayout.NORTH);
        yImgPanel.add(hilfsPanel, BorderLayout.CENTER);
        flow = new JPanel();
        flow.setLayout(new BorderLayout());

        if (firststart)
            flow.add(yImgPanel, BorderLayout.WEST);

        if (firststart) {
            p = new JPanel();
            p2 = new JPanel();
            p.setLayout(new BorderLayout());
            p2.setLayout(new BorderLayout());
            mylabel = new JLabel("Kodierungsalgorithmus:");
            p.add(mylabel, BorderLayout.NORTH);
            huffmanCombo = new JComboBox(huffmanComboStrings);
            huffmanCombo.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    comboBoxAuswahl();
                }});
                
            p.add(huffmanCombo, BorderLayout.SOUTH);
            p2.add(p, BorderLayout.NORTH);
            flow.add(p2,BorderLayout.EAST);
    
            add(flow, BorderLayout.CENTER);
        } // if (firststart)
 
        JPanel oberPan=new JPanel();
        oberPan.setLayout(new BoxLayout(oberPan, BoxLayout.Y_AXIS));
        p = new JPanel();
        p.setLayout(new BorderLayout(15,5));
        p.add(new JLabel("Darstellung des aktuellen Blocks:"),BorderLayout.NORTH);
        BufferedImage blockDiag = FrameVisJPEG.vis.ourImage.paintHuffmanSizes(450, 100, Color.black, Color.blue, Color.red, Color.green);
        OurImage oi = new OurImage(blockDiag);
        oi.setPreferredSize(new Dimension(450, 105));
        oi.setMinimumSize(new Dimension(450, 105));
        oi.setMaximumSize(new Dimension(450, 105));
        p.add(oi, BorderLayout.CENTER);
        oberPan.add(p);
     
        p = new JPanel();
        p.setLayout(new BorderLayout(15,5));
        p.add(new JLabel("Lngenverteilung in der Huffman-Tabelle:"),BorderLayout.NORTH);
        tabellenDiagramm.setPreferredSize(new Dimension(450, 95));
        tabellenDiagramm.setMinimumSize(new Dimension(450, 95));
        tabellenDiagramm.setMaximumSize(new Dimension(450, 95));
        p.add(tabellenDiagramm,BorderLayout.CENTER);
        oberPan.add(p);
      
        p = new JPanel();
        p.setLayout(new BorderLayout(15,5));
        p.add(new JLabel("Lngenverteilung im kodierten Datenstrom:"),BorderLayout.NORTH);
        bildDatenDiagramm.setPreferredSize(new Dimension(450, 90));
        bildDatenDiagramm.setMinimumSize(new Dimension(450, 90));
        bildDatenDiagramm.setMaximumSize(new Dimension(450, 90));
        p.add(bildDatenDiagramm,BorderLayout.CENTER);
        oberPan.add(p);
        dynpanel.add(oberPan, BorderLayout.SOUTH);
       
        p = new JPanel();
        p2 = new JPanel();
        p2.setLayout(new BorderLayout());
        JPanel labelzPanel = new JPanel();
        labelzPanel.setLayout(new BoxLayout(labelzPanel, BoxLayout.Y_AXIS));
        labelzPanel.add(new JLabel("Kompression in"));
        labelzPanel.add(new JLabel("diesem Schritt um:"));
        p2.add(labelzPanel, BorderLayout.NORTH);
        JProgressBar progressBar = new JProgressBar(JProgressBar.VERTICAL);
        progressBar.setMinimum(0);
        progressBar.setMaximum(100);
        progressBar.setValue(huffmanRatio);
        progressBar.setString((new Integer(100-huffmanRatio)).toString() + "%");
        progressBar.setStringPainted(true);  
        p.add(progressBar);
        p2.add(p, BorderLayout.CENTER);
        compressPanel.add(p2, BorderLayout.EAST);
    } // addKomponets()
    
      
    public void update() {
        dynpanel.removeAll();
        yImgPanel.removeAll();
        compressPanel.removeAll();
        addKomponets(false);  
        validate();
    } //update

}

/*

PanelEntropie: BorderLayout
    NORTH: BorderLayout
        WEST: "Schritt 6: ..."
        EAST: FlowLayout: "Zurck", "Info", "Weiter"

    CENTER: BorderLayout (flow)
        WEST: BorderLayout (yImgPanel)                                           *
            CENTER: OurImage (yImage), feste Gre: 192*144                      *
        EAST: BorderLayout
            NORTH: BorderLayout
                NORTH: "Kodierungsalgorithmus"
                SOUTH: JComboBox (huffmanCombo)

    SOUTH: BorderLayout
        CENTER: BorderLayout (dynpanel)                                          *
            SOUTH: BoxLayout Y_AXIS (oberPan)                                    *
                BorderLayout                                                     *
                    NORTH: "Darstellung des aktuellen Blocks"                    *
                    CENTER: OurImage, feste Gre: 450*110                       *
                BorderLayout:                                                    *
                    NORTH: "Lngenverteilung in der Huffman-Tabelle"             * 
                    CENTER: Panel (tabellenDiagramm), feste Gre: 450*100       *
                BorderLayout:                                                    *
                    NORTH: "Lngenverteilung im codierten Datenstrom"            *
                    CENTER: Panel (bildDatenDiagramm), feste Gre: 450*90       *
        EAST: BorderLayout
            SOUTH: BorderLayout (compressPanel)                                  *
                EAST: BorderLayout                                               *
                    NORTH: BoxLayout Y_AXIS                                      *
                        Label "Datenreduktion"                                   *
                        Label "in diesem Schritt"                                *
                    CENTER: Panel, JProgressBar                                  *


 *   Inhalt des Panels wird in update() geleert
 
*/