import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;
import java.lang.*;

/**
 * Folge von <CODE>RLESymbol1</CODE>'s und <CODE>RLESymbol2</CODE>'s.
 * @author Hari
 * @version 1 - 27.12.99
 */
public class RLESymbolfolge {
    private Vector symbole;

    /**
     * Konstruktor, erzeugt leere Folge
     * @author Hari
     * @version 1
     * @returns RLESymbolfolge
     */
    public RLESymbolfolge() {
    	symbole = new Vector();
    }
	
    /**
     * Liefert die Anzahl der Symbole in der Folge
     * @author Hari
     * @version 1
     * @returns int
     */
    public int size() {
        return symbole.size();
    }
    
    /**
     * Liefert das <CODE>RLESymbol</CODE> an der Position <CODE>i</CODE>
     * @author Hari
     * @version 1
     * @returns RLESymbol
     */
    public RLESymbol elementAt(int i) {
        return (RLESymbol)symbole.elementAt(i);
    }
    
    /**
     * Fgt eine zweite <CODE>RLESymbolfolgen</CODE> zu dieser hinzu
     * @author Hari
     * @version 1
     * @param RLESymbolfolge
     */
    public void concat(RLESymbolfolge folge) {
    	for (int i=0; i<folge.symbole.size(); i++)
    		symbole.addElement(folge.symbole.elementAt(i));
    }
	
    /**
     * Baut ein zustzliches Element in die Symbolfolge ein
     * @author Hari
     * @version 1
     * @param RLESymbol
     */
	public void addElement(RLESymbol symb) {
		symbole.addElement(symb);
	}
	
   /**
     * Macht aus einem <CODE>int[]</CODE> von DC Werten eine
     * <CODE>RLESymbolfolge</CODE> fr <CODE>doDPCMCoding()</CODE>.
     * Die Folge enthlt abwechselnd symbol1-symbol2-....
     * Die symbol1's sind nicht initialisiert, die symbol2's
     * enthalten die <CODE>int[]</CODE> Werte
     * @author Hari
     * @version 1
     * @param int[]
     * @returns RLESymbolfolge
     */
    public static RLESymbolfolge getDCSymbols(int werte[]) {
    	RLESymbolfolge folge;
    	RLESymbol symb;
    	
    	folge = new RLESymbolfolge();    	
    	for (int i=0; i<werte.length; i++) {
    		symb = new RLESymbol1();
    		folge.addElement(symb);
    		symb = new RLESymbol2();
    		((RLESymbol2)symb).amplitude = werte[i];
    		folge.addElement(symb);
    	}
    	return folge;
    }
     
    /**
     * Klont die <CODE>RLESymbolfolge</CODE> und liefert sie als
     * <CODE>Object</CODE> zurck
     * @author Hari
     * @returns Object
     */
    public Object clone() {
    	RLESymbolfolge folge;
    	int i;
    	
    	folge = new RLESymbolfolge();
    	for (i=0; i<this.symbole.size(); i++)
    		folge.addElement((RLESymbol)this.symbole.elementAt(i));
    	return (Object)folge;
    }
}