import java.awt.*;
import java.awt.event.*;
import java.net.*;

/**
 * Diese Klasse dient zum Erzeugen des tollen Splash Screens fr unser Prog.
 * Ich hab das aus einem Buch bernommen, ich gebs zu!
 * @author Hari
 */
public class SplashFrame extends Frame {
  /**
   * @serial
   */  
  Toolkit toolkit = Toolkit.getDefaultToolkit();
  /**
   * @serial
   */  
  Window window;
  /**
   * @serial
   */  
  Image image;

  public SplashFrame(String filename) {
    ImageCanvas canvas;
    if (JPEG.isApplication) {
        image = toolkit.getImage(filename);
    } else {
        try {
            image = JPEG.applet.getImage(new URL(JPEG.appletCodeBase, filename));
        } catch (MalformedURLException e) { return; }
    }
    window = new Window(this);
    canvas = new ImageCanvas(image);
    window.add(canvas, "Center");

    Dimension scrnSize= toolkit.getScreenSize();
    int imgWidth = image.getWidth(this);
    int imgHeight = image.getHeight(this);

    window.setLocation(scrnSize.width/2 - imgWidth/2, scrnSize.height/2 - imgHeight/2);
    window.setSize(imgWidth, imgHeight);
    window.show();
    window.toFront();
  }

  private class ImageCanvas extends Canvas {
    private Image image;

    public ImageCanvas(Image image) {
      MediaTracker mt = new MediaTracker(this);
      mt.addImage(image, 0);
      try { mt.waitForID(0); }
      catch(Exception e) { e.printStackTrace(); }
      this.image = image;
    }

    public void paint(Graphics g) {
      g.drawImage(image, 0, 0, this);
    }

    public void update(Graphics g) {
      paint(g);
    }

    public Dimension getPreferredSize() {
      return new Dimension(image.getWidth(this), image.getHeight(this));
    }
  }
}